// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 34 "src/parser.yy" // lalr1.cc:404

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 45 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "parser.tab.hh"

// User implementation prologue.

#line 59 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy" // lalr1.cc:479
namespace  bpftrace  {
#line 145 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
   Parser ::by_state::by_state ()
    : state (empty_state)
  {}

  inline
   Parser ::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
   Parser ::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
   Parser ::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
   Parser ::symbol_number_type
   Parser ::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
   Parser ::stack_symbol_type::stack_symbol_type ()
  {}


  inline
   Parser ::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 80: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case 79: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case 113: // call
        value.move< ast::Call * > (that.value);
        break;

      case 93: // primary_expr
      case 94: // postfix_expr
      case 95: // tuple_access_expr
      case 96: // unary_expr
      case 98: // expr
      case 99: // conditional_expr
      case 100: // logical_or_expr
      case 101: // logical_and_expr
      case 102: // or_expr
      case 103: // xor_expr
      case 104: // and_expr
      case 105: // equality_expr
      case 106: // relational_expr
      case 107: // shift_expr
      case 108: // muli_expr
      case 109: // addi_expr
      case 110: // cast_expr
      case 116: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case 117: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case 111: // int
        value.move< ast::Integer * > (that.value);
        break;

      case 114: // map
        value.move< ast::Map * > (that.value);
        break;

      case 97: // unary_op
      case 118: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case 83: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case 82: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case 78: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case 77: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case 86: // block_stmt
      case 87: // expr_stmt
      case 88: // jump_stmt
      case 89: // loop_stmt
      case 90: // if_stmt
      case 92: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case 84: // block
      case 85: // stmt_list
      case 91: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case 115: // var
        value.move< ast::Variable * > (that.value);
        break;

      case 72: // "integer"
        value.move< long > (that.value);
        break;

      case 60: // "builtin"
      case 61: // "call"
      case 62: // "call_builtin"
      case 63: // "identifier"
      case 64: // "path"
      case 65: // "preprocessor directive"
      case 66: // "struct definition"
      case 67: // "enum"
      case 68: // "string"
      case 69: // "map"
      case 70: // "variable"
      case 71: // "positional parameter"
      case 73: // "stack_mode"
      case 76: // c_definitions
      case 81: // attach_point_def
      case 112: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 80: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case 79: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case 113: // call
        value.copy< ast::Call * > (that.value);
        break;

      case 93: // primary_expr
      case 94: // postfix_expr
      case 95: // tuple_access_expr
      case 96: // unary_expr
      case 98: // expr
      case 99: // conditional_expr
      case 100: // logical_or_expr
      case 101: // logical_and_expr
      case 102: // or_expr
      case 103: // xor_expr
      case 104: // and_expr
      case 105: // equality_expr
      case 106: // relational_expr
      case 107: // shift_expr
      case 108: // muli_expr
      case 109: // addi_expr
      case 110: // cast_expr
      case 116: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case 117: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case 111: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case 114: // map
        value.copy< ast::Map * > (that.value);
        break;

      case 97: // unary_op
      case 118: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case 83: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case 82: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case 78: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case 77: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case 86: // block_stmt
      case 87: // expr_stmt
      case 88: // jump_stmt
      case 89: // loop_stmt
      case 90: // if_stmt
      case 92: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case 84: // block
      case 85: // stmt_list
      case 91: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case 115: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case 72: // "integer"
        value.copy< long > (that.value);
        break;

      case 60: // "builtin"
      case 61: // "call"
      case 62: // "call_builtin"
      case 63: // "identifier"
      case 64: // "path"
      case 65: // "preprocessor directive"
      case 66: // "struct definition"
      case 67: // "enum"
      case 68: // "string"
      case 69: // "map"
      case 70: // "variable"
      case 71: // "positional parameter"
      case 73: // "stack_mode"
      case 76: // c_definitions
      case 81: // attach_point_def
      case 112: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
   Parser ::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
   Parser ::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
   Parser ::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline  Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 80: // attach_point
        yylhs.value.build< ast::AttachPoint * > ();
        break;

      case 79: // attach_points
        yylhs.value.build< ast::AttachPointList * > ();
        break;

      case 113: // call
        yylhs.value.build< ast::Call * > ();
        break;

      case 93: // primary_expr
      case 94: // postfix_expr
      case 95: // tuple_access_expr
      case 96: // unary_expr
      case 98: // expr
      case 99: // conditional_expr
      case 100: // logical_or_expr
      case 101: // logical_and_expr
      case 102: // or_expr
      case 103: // xor_expr
      case 104: // and_expr
      case 105: // equality_expr
      case 106: // relational_expr
      case 107: // shift_expr
      case 108: // muli_expr
      case 109: // addi_expr
      case 110: // cast_expr
      case 116: // map_or_var
        yylhs.value.build< ast::Expression * > ();
        break;

      case 117: // vargs
        yylhs.value.build< ast::ExpressionList * > ();
        break;

      case 111: // int
        yylhs.value.build< ast::Integer * > ();
        break;

      case 114: // map
        yylhs.value.build< ast::Map * > ();
        break;

      case 97: // unary_op
      case 118: // compound_op
        yylhs.value.build< ast::Operator > ();
        break;

      case 83: // param
        yylhs.value.build< ast::PositionalParameter * > ();
        break;

      case 82: // pred
        yylhs.value.build< ast::Predicate * > ();
        break;

      case 78: // probe
        yylhs.value.build< ast::Probe * > ();
        break;

      case 77: // probes
        yylhs.value.build< ast::ProbeList * > ();
        break;

      case 86: // block_stmt
      case 87: // expr_stmt
      case 88: // jump_stmt
      case 89: // loop_stmt
      case 90: // if_stmt
      case 92: // assign_stmt
        yylhs.value.build< ast::Statement * > ();
        break;

      case 84: // block
      case 85: // stmt_list
      case 91: // block_or_if
        yylhs.value.build< ast::StatementList * > ();
        break;

      case 115: // var
        yylhs.value.build< ast::Variable * > ();
        break;

      case 72: // "integer"
        yylhs.value.build< long > ();
        break;

      case 60: // "builtin"
      case 61: // "call"
      case 62: // "call_builtin"
      case 63: // "identifier"
      case 64: // "path"
      case 65: // "preprocessor directive"
      case 66: // "struct definition"
      case 67: // "enum"
      case 68: // "string"
      case 69: // "map"
      case 70: // "variable"
      case 71: // "positional parameter"
      case 73: // "stack_mode"
      case 76: // c_definitions
      case 81: // attach_point_def
      case 112: // ident
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 162 "src/parser.yy" // lalr1.cc:859
    { driver.root = std::make_unique<ast::Program>(yystack_[2].value.as< std::string > (), yystack_[1].value.as< ast::ProbeList * > ()); }
#line 845 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 3:
#line 166 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "\n" + yystack_[0].value.as< std::string > (); }
#line 851 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 4:
#line 167 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + ";\n" + yystack_[0].value.as< std::string > (); }
#line 857 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 5:
#line 168 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + ";\n" + yystack_[0].value.as< std::string > (); }
#line 863 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 6:
#line 169 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::string(); }
#line 869 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 7:
#line 173 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::ProbeList * > () = yystack_[1].value.as< ast::ProbeList * > (); yystack_[1].value.as< ast::ProbeList * > ()->push_back(yystack_[0].value.as< ast::Probe * > ()); }
#line 875 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 8:
#line 174 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as< ast::ProbeList * > ()->push_back(yystack_[0].value.as< ast::Probe * > ()); }
#line 881 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 9:
#line 179 "src/parser.yy" // lalr1.cc:859
    {
                  if (!driver.listing_)
                    yylhs.value.as< ast::Probe * > () = new ast::Probe(yystack_[2].value.as< ast::AttachPointList * > (), yystack_[1].value.as< ast::Predicate * > (), yystack_[0].value.as< ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 895 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 10:
#line 189 "src/parser.yy" // lalr1.cc:859
    {
                  if (driver.listing_)
                    yylhs.value.as< ast::Probe * > () = new ast::Probe(yystack_[1].value.as< ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 909 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 11:
#line 201 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::AttachPointList * > () = yystack_[2].value.as< ast::AttachPointList * > (); yystack_[2].value.as< ast::AttachPointList * > ()->push_back(yystack_[0].value.as< ast::AttachPoint * > ()); }
#line 915 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 12:
#line 202 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as< ast::AttachPointList * > ()->push_back(yystack_[0].value.as< ast::AttachPoint * > ()); }
#line 921 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 13:
#line 206 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 927 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 14:
#line 210 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + yystack_[0].value.as< std::string > (); }
#line 933 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 15:
#line 214 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "\"" + std::regex_replace(yystack_[0].value.as< std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 939 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 16:
#line 215 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + yystack_[0].value.as< std::string > (); }
#line 945 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 17:
#line 216 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + std::to_string(yystack_[0].value.as< long > ()); }
#line 951 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 18:
#line 217 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + ":"; }
#line 957 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 19:
#line 218 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "."; }
#line 963 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 20:
#line 219 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "+"; }
#line 969 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 21:
#line 220 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "*"; }
#line 975 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 22:
#line 221 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "["; }
#line 981 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 23:
#line 222 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "]"; }
#line 987 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 24:
#line 224 "src/parser.yy" // lalr1.cc:859
    {
                  if (yystack_[0].value.as< ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as< std::string > () = yystack_[1].value.as< std::string > () + "$" + std::to_string(yystack_[0].value.as< ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as< ast::PositionalParameter * > ();
                }
#line 1004 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 25:
#line 236 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = ""; }
#line 1010 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 26:
#line 240 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as< ast::Expression * > (), yylhs.location); }
#line 1016 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 27:
#line 241 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Predicate * > () = nullptr; }
#line 1022 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 28:
#line 246 "src/parser.yy" // lalr1.cc:859
    {
                        try {
                          long n = std::stol(yystack_[0].value.as< std::string > ().substr(1, yystack_[0].value.as< std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as< ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as< std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1038 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 29:
#line 257 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1044 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 30:
#line 261 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = yystack_[1].value.as< ast::StatementList * > (); }
#line 1050 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 31:
#line 268 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = yystack_[0].value.as< ast::StatementList * > (); yystack_[0].value.as< ast::StatementList * > ()->insert(yystack_[0].value.as< ast::StatementList * > ()->begin(), yystack_[2].value.as< ast::Statement * > ()); }
#line 1056 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 32:
#line 269 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = new ast::StatementList; yylhs.value.as< ast::StatementList * > ()->push_back(yystack_[0].value.as< ast::Statement * > ()); }
#line 1062 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 33:
#line 273 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = yystack_[0].value.as< ast::StatementList * > (); yystack_[0].value.as< ast::StatementList * > ()->insert(yystack_[0].value.as< ast::StatementList * > ()->begin(), yystack_[1].value.as< ast::Statement * > ()); }
#line 1068 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 34:
#line 274 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = new ast::StatementList; }
#line 1074 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 35:
#line 278 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = yystack_[0].value.as< ast::Statement * > (); }
#line 1080 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 36:
#line 279 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = yystack_[0].value.as< ast::Statement * > (); }
#line 1086 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 37:
#line 283 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as< ast::Expression * > (), yystack_[0].location); }
#line 1092 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 38:
#line 284 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = yystack_[0].value.as< ast::Statement * > (); }
#line 1098 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 39:
#line 289 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = yystack_[0].value.as< ast::Statement * > (); }
#line 1104 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 40:
#line 293 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1110 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 41:
#line 294 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1116 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 42:
#line 295 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1122 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 43:
#line 299 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::Unroll(yystack_[2].value.as< ast::Integer * > (), yystack_[0].value.as< ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1128 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 44:
#line 300 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::Unroll(yystack_[2].value.as< ast::PositionalParameter * > (), yystack_[0].value.as< ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1134 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 45:
#line 301 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::While(yystack_[2].value.as< ast::Expression * > (), yystack_[0].value.as< ast::StatementList * > (), yystack_[4].location); }
#line 1140 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 46:
#line 305 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::If(yystack_[2].value.as< ast::Expression * > (), yystack_[0].value.as< ast::StatementList * > ()); }
#line 1146 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 47:
#line 306 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::If(yystack_[4].value.as< ast::Expression * > (), yystack_[2].value.as< ast::StatementList * > (), yystack_[0].value.as< ast::StatementList * > ()); }
#line 1152 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 48:
#line 310 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = yystack_[0].value.as< ast::StatementList * > (); }
#line 1158 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 49:
#line 311 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::StatementList * > () = new ast::StatementList; yylhs.value.as< ast::StatementList * > ()->emplace_back(yystack_[0].value.as< ast::Statement * > ()); }
#line 1164 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 50:
#line 316 "src/parser.yy" // lalr1.cc:859
    {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1173 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 51:
#line 320 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as< ast::Map * > (), yystack_[0].value.as< ast::Expression * > (), false, yystack_[1].location); }
#line 1179 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 52:
#line 321 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as< ast::Variable * > (), yystack_[0].value.as< ast::Expression * > (), false, yystack_[1].location); }
#line 1185 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 53:
#line 323 "src/parser.yy" // lalr1.cc:859
    {
                  auto b = new ast::Binop(yystack_[2].value.as< ast::Map * > (), yystack_[1].value.as< ast::Operator > (), yystack_[0].value.as< ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as< ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as< ast::Map * > (), b, true, yylhs.location);
                }
#line 1194 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 54:
#line 328 "src/parser.yy" // lalr1.cc:859
    {
                  auto b = new ast::Binop(yystack_[2].value.as< ast::Variable * > (), yystack_[1].value.as< ast::Operator > (), yystack_[0].value.as< ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as< ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as< ast::Variable * > (), b, true, yylhs.location);
                }
#line 1203 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 55:
#line 335 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Identifier(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1209 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 56:
#line 336 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Integer * > (); }
#line 1215 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 57:
#line 337 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::String(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1221 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 58:
#line 338 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::StackMode(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1227 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 59:
#line 339 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Builtin(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1233 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 60:
#line 340 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Builtin(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1239 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 61:
#line 341 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[1].value.as< ast::Expression * > (); }
#line 1245 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 62:
#line 342 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::PositionalParameter * > (); }
#line 1251 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 63:
#line 343 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1257 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 64:
#line 345 "src/parser.yy" // lalr1.cc:859
    {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as< ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as< ast::ExpressionList * > ()->begin(), yystack_[1].value.as< ast::ExpressionList * > ()->end());
                  yylhs.value.as< ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1268 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 65:
#line 354 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1274 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 66:
#line 356 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as< ast::Expression * > (), yystack_[0].value.as< std::string > (), yystack_[1].location); }
#line 1280 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 67:
#line 357 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as< ast::Expression * > (), yystack_[1].location), yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1286 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 68:
#line 359 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1292 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 69:
#line 361 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as< ast::Expression * > (), yystack_[1].value.as< ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1298 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 70:
#line 362 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Call * > (); }
#line 1304 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 71:
#line 363 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as< ast::Expression * > (), true, yystack_[0].location); }
#line 1310 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 72:
#line 364 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as< ast::Expression * > (), true, yystack_[0].location); }
#line 1316 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 73:
#line 366 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1322 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 74:
#line 367 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1328 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 75:
#line 372 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as< ast::Expression * > (), yystack_[0].value.as< long > (), yystack_[0].location); }
#line 1334 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 76:
#line 378 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Unop(yystack_[1].value.as< ast::Operator > (), yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1340 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 77:
#line 379 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1346 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 78:
#line 380 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1352 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 79:
#line 381 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1358 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 80:
#line 383 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1364 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 81:
#line 384 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1370 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 82:
#line 388 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::MUL; }
#line 1376 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 83:
#line 389 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::BNOT; }
#line 1382 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 84:
#line 390 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::LNOT; }
#line 1388 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 85:
#line 391 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::MINUS; }
#line 1394 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 86:
#line 395 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1400 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 87:
#line 399 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1406 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 88:
#line 400 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Ternary(yystack_[4].value.as< ast::Expression * > (), yystack_[2].value.as< ast::Expression * > (), yystack_[0].value.as< ast::Expression * > (), yylhs.location); }
#line 1412 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 89:
#line 405 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1418 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 90:
#line 406 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1424 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 91:
#line 410 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1430 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 92:
#line 411 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1436 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 93:
#line 415 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1442 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 94:
#line 416 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1448 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 95:
#line 420 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1454 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 96:
#line 421 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1460 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 97:
#line 426 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1466 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 98:
#line 427 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1472 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 99:
#line 431 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1478 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 100:
#line 432 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1484 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 101:
#line 433 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1490 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 102:
#line 437 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1496 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 103:
#line 438 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1502 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 104:
#line 439 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1508 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 105:
#line 440 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1514 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 106:
#line 441 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1520 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 107:
#line 445 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1526 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 108:
#line 446 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1532 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 109:
#line 447 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1538 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 110:
#line 451 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1544 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 111:
#line 452 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1550 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 112:
#line 453 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1556 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 113:
#line 454 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1562 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 114:
#line 458 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1568 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 115:
#line 459 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1574 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 116:
#line 460 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Binop(yystack_[2].value.as< ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as< ast::Expression * > (), yystack_[1].location); }
#line 1580 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 117:
#line 464 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Expression * > (); }
#line 1586 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 118:
#line 465 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Cast(yystack_[2].value.as< std::string > (), false, false, yystack_[0].value.as< ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1592 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 119:
#line 466 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Cast(yystack_[3].value.as< std::string > (), true, false, yystack_[0].value.as< ast::Expression * > (), yystack_[4].location + yystack_[2].location); }
#line 1598 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 120:
#line 467 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = new ast::Cast(yystack_[4].value.as< std::string > (), true, true, yystack_[0].value.as< ast::Expression * > (), yystack_[5].location + yystack_[3].location); }
#line 1604 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 121:
#line 471 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Integer * > () = new ast::Integer((long)(~(unsigned long)(yystack_[0].value.as< long > ()) + 1), yylhs.location); }
#line 1610 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 122:
#line 472 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Integer * > () = new ast::Integer(yystack_[0].value.as< long > (), yylhs.location); }
#line 1616 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 123:
#line 476 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > (); }
#line 1622 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 124:
#line 477 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > (); }
#line 1628 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 125:
#line 478 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > (); }
#line 1634 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 126:
#line 479 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > (); }
#line 1640 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 127:
#line 480 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > (); }
#line 1646 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 128:
#line 484 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Call * > () = new ast::Call(yystack_[2].value.as< std::string > (), yylhs.location); }
#line 1652 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 129:
#line 485 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Call * > () = new ast::Call(yystack_[3].value.as< std::string > (), yystack_[1].value.as< ast::ExpressionList * > (), yylhs.location); }
#line 1658 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 130:
#line 486 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Call * > () = new ast::Call(yystack_[2].value.as< std::string > (), yylhs.location); }
#line 1664 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 131:
#line 487 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Call * > () = new ast::Call(yystack_[3].value.as< std::string > (), yystack_[1].value.as< ast::ExpressionList * > (), yylhs.location); }
#line 1670 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 132:
#line 488 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as< std::string > ()); YYERROR;  }
#line 1676 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 133:
#line 489 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as< std::string > ()); YYERROR;  }
#line 1682 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 134:
#line 490 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as< std::string > ()); YYERROR;  }
#line 1688 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 135:
#line 491 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as< std::string > ()); YYERROR;  }
#line 1694 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 136:
#line 492 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as< std::string > ()); YYERROR;  }
#line 1700 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 137:
#line 493 "src/parser.yy" // lalr1.cc:859
    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as< std::string > ()); YYERROR;  }
#line 1706 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 138:
#line 497 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Map * > () = new ast::Map(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1712 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 139:
#line 498 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Map * > () = new ast::Map(yystack_[3].value.as< std::string > (), yystack_[1].value.as< ast::ExpressionList * > (), yylhs.location); }
#line 1718 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 140:
#line 502 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Variable * > () = new ast::Variable(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1724 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 141:
#line 506 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Variable * > (); }
#line 1730 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 142:
#line 507 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Expression * > () = yystack_[0].value.as< ast::Map * > (); }
#line 1736 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 143:
#line 511 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::ExpressionList * > () = yystack_[2].value.as< ast::ExpressionList * > (); yystack_[2].value.as< ast::ExpressionList * > ()->push_back(yystack_[0].value.as< ast::Expression * > ()); }
#line 1742 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 144:
#line 512 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as< ast::ExpressionList * > ()->push_back(yystack_[0].value.as< ast::Expression * > ()); }
#line 1748 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 145:
#line 516 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::LEFT; }
#line 1754 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 146:
#line 517 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::BAND; }
#line 1760 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 147:
#line 518 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::BOR; }
#line 1766 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 148:
#line 519 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::BXOR; }
#line 1772 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 149:
#line 520 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::DIV; }
#line 1778 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 150:
#line 521 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::MINUS; }
#line 1784 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 151:
#line 522 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::MOD; }
#line 1790 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 152:
#line 523 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::MUL; }
#line 1796 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 153:
#line 524 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::PLUS; }
#line 1802 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;

  case 154:
#line 525 "src/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::Operator > () = ast::Operator::RIGHT; }
#line 1808 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
    break;


#line 1812 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char  Parser ::yypact_ninf_ = -123;

  const signed char  Parser ::yytable_ninf_ = -128;

  const short int
   Parser ::yypact_[] =
  {
     137,   137,   137,   137,    46,  -123,  -123,  -123,  -123,  -123,
      75,  -123,    17,  -123,     8,  -123,  -123,  -123,  -123,   359,
      82,  -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,
    -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,
     398,    80,    37,    80,  -123,  -123,  -123,    18,    91,    74,
      79,  -123,   108,  -123,  -123,    90,  -123,  -123,     1,  -123,
    -123,   359,   126,  -123,     7,    96,    86,   100,   139,    -4,
     136,    -1,   174,    48,  -123,  -123,   112,  -123,  -123,  -123,
     117,    64,  -123,    57,    85,  -123,  -123,  -123,  -123,  -123,
     138,   203,   242,   281,   359,   320,   359,   172,   -37,  -123,
    -123,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
    -123,  -123,  -123,  -123,   220,   229,   244,  -123,  -123,  -123,
     248,    64,   251,  -123,  -123,  -123,  -123,   247,  -123,   160,
     190,   359,     4,  -123,   359,  -123,  -123,   118,  -123,   147,
    -123,   173,  -123,   218,    39,  -123,   226,   249,  -123,  -123,
    -123,   265,    96,    86,   100,   139,    -4,   136,   136,    -1,
      -1,    -1,    -1,    48,    48,  -123,  -123,  -123,   174,   174,
     359,    -7,   359,  -123,  -123,    64,   359,   359,  -123,  -123,
    -123,  -123,  -123,  -123,  -123,  -123,  -123,  -123,   359,   359,
     359,  -123,   359,   260,   227,  -123,   359,  -123,  -123,  -123,
    -123,  -123,  -123,   359,   267,    37,   268,   269,   273,  -123,
    -123,  -123,  -123,  -123,  -123,  -123,   359,  -123,  -123,  -123,
      82,    82,    82,    82,  -123,   233,  -123,  -123,  -123,     5,
    -123,  -123,  -123
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    25,     3,     4,     5,     1,
      25,     8,    27,    12,    13,     2,     7,    10,    25,     0,
       0,    18,    22,    23,    29,    20,    21,    19,   124,   125,
     126,   123,    16,    15,    28,    17,   127,    24,    14,    11,
       0,     0,    85,     0,    82,    84,    83,    59,   125,    60,
      55,    57,   138,   140,   122,    58,    62,    65,    77,    68,
     117,     0,     0,    86,    87,    89,    91,    93,    95,    97,
      99,   102,   114,   107,   110,    56,     0,    70,   142,   141,
      63,    34,     9,    55,     0,    73,    78,   121,    74,    79,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    76,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      81,    80,    71,    72,     0,     0,     0,    42,    41,    40,
       0,    34,    32,    38,    35,    36,    39,    68,    37,   142,
     141,     0,     0,    61,     0,   134,   144,     0,   128,     0,
     130,     0,   132,     0,     0,   136,     0,     0,    75,    66,
      67,     0,    90,    92,    94,    96,    98,   100,   101,   103,
     104,   105,   106,   108,   109,   111,   112,   113,   115,   116,
       0,     0,     0,    30,    33,    34,     0,     0,   145,   154,
     153,   150,   152,   149,   151,   146,   147,   148,     0,     0,
       0,   118,     0,     0,     0,   135,     0,   129,   131,   133,
     139,   137,    69,     0,     0,     0,     0,     0,     0,    31,
      50,    51,    53,    52,    54,   119,     0,    64,   143,    88,
       0,     0,     0,     0,   120,    46,    44,    43,    45,     0,
      48,    49,    47
  };

  const short int
   Parser ::yypgoto_[] =
  {
    -123,  -123,   245,  -123,   275,  -123,   274,  -123,  -123,   -12,
      28,  -122,  -123,  -123,  -123,  -123,    47,  -123,  -123,  -123,
    -123,   -80,  -123,  -123,   -19,    81,  -123,   185,   193,   189,
     192,   194,   -79,    62,   -81,   -20,   -56,   120,    -8,  -123,
     -78,   -77,   121,   -52,   158
  };

  const short int
   Parser ::yydefgoto_[] =
  {
      -1,     4,     5,    10,    11,    12,    13,    14,    20,    56,
      82,   130,   131,   132,   133,   134,   135,   242,   136,    57,
      58,    59,    60,    61,   146,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,   147,   198
  };

  const short int
   Parser ::yytable_[] =
  {
      62,   137,    37,   139,   140,    99,    38,    24,    96,   184,
      81,    21,   107,   108,   202,    22,    23,    17,   101,   113,
     114,    84,    24,    28,    29,    30,    31,    90,   167,   168,
      18,   215,   102,    85,    25,    88,    36,   178,   179,   149,
     151,   153,   154,   156,   203,  -124,     9,   210,    26,    97,
      98,   137,   206,   139,   140,   124,    27,  -124,    19,   175,
     176,   177,   138,   219,    34,    54,    93,   141,    28,    29,
      30,    31,    32,    40,   118,    15,    33,   157,    24,    34,
      35,    36,   161,    92,  -123,   201,   119,    81,    93,   159,
     160,    41,   204,   173,   174,   143,  -123,   142,   144,    95,
      91,  -126,    42,    43,    44,   137,  -123,   139,   140,    87,
      45,    46,   138,  -126,   124,    94,   125,  -127,  -123,   126,
     103,   127,   128,   129,    47,    48,    49,    50,   205,  -127,
     104,   206,    51,    52,    53,    34,    54,    55,   100,   120,
      28,    29,    30,    31,   122,   105,   225,    40,   145,    52,
      53,   121,    24,    36,   109,   110,   123,   207,   111,   112,
     206,   214,    86,   218,    89,    41,   138,   220,   221,   216,
     234,   169,   170,   171,   172,   187,    42,    43,    44,   222,
     223,   224,   106,   208,    45,    46,   206,   228,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    47,    48,
      49,    50,     1,     2,     3,   199,    51,    52,    53,    34,
      54,    55,    40,   148,   115,   116,   117,    24,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   209,   180,
      41,   206,    28,    29,    30,    31,   211,   227,   181,   206,
     206,    42,    43,    44,   158,    36,     6,     7,     8,    45,
      46,    40,   150,   182,   183,   185,    24,   212,   235,   236,
     237,   238,   186,    47,    48,    49,    50,   240,   213,    41,
     226,    51,    52,    53,    34,    54,    55,   230,   231,   232,
      42,    43,    44,   233,   239,    16,   241,   162,    45,    46,
      40,   152,    39,   164,   229,    24,   163,   165,   200,     0,
     166,   217,    47,    48,    49,    50,     0,     0,    41,     0,
      51,    52,    53,    34,    54,    55,     0,     0,     0,    42,
      43,    44,     0,     0,     0,     0,     0,    45,    46,    40,
     155,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,    47,    48,    49,    50,     0,     0,    41,     0,    51,
      52,    53,    34,    54,    55,     0,     0,     0,    42,    43,
      44,     0,     0,     0,     0,     0,    45,    46,    40,     0,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
      47,    48,    49,    50,     0,     0,    41,     0,    51,    52,
      53,    34,    54,    55,     0,     0,     0,    42,    43,    44,
       0,     0,     0,     0,     0,    45,    46,    40,     0,     0,
       0,     0,    24,     0,     0,     0,     0,     0,     0,    47,
      48,    49,    50,     0,     0,    41,     0,    51,    52,    53,
      34,    54,    55,     0,     0,     0,    42,    43,    44,     0,
       0,     0,     0,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    47,    48,
      49,    83,     0,     0,     0,     0,    51,    52,    53,    34,
      54,    55
  };

  const short int
   Parser ::yycheck_[] =
  {
      19,    81,    14,    81,    81,    61,    14,    14,     7,   131,
       5,     3,    16,    17,    10,     7,     8,     0,    11,    20,
      21,    40,    14,    60,    61,    62,    63,     9,   107,   108,
      13,    38,    25,    41,    26,    43,    73,   118,   119,    91,
      92,    93,    94,    95,    40,    27,     0,     8,    40,    48,
      49,   131,    13,   131,   131,    50,    48,    39,    41,   115,
     116,   117,    81,   185,    71,    72,     9,    10,    60,    61,
      62,    63,    64,     9,    26,     0,    68,    96,    14,    71,
      72,    73,   101,     9,    27,   141,    38,     5,     9,    97,
      98,    27,   144,   113,   114,    10,    39,    40,    13,     9,
       9,    27,    38,    39,    40,   185,    27,   185,   185,    72,
      46,    47,   131,    39,    50,     7,    52,    27,    39,    55,
      24,    57,    58,    59,    60,    61,    62,    63,    10,    39,
      44,    13,    68,    69,    70,    71,    72,    73,    12,    27,
      60,    61,    62,    63,    27,    45,   202,     9,    10,    69,
      70,    39,    14,    73,    18,    19,    39,    10,    22,    23,
      13,   180,    41,   182,    43,    27,   185,   186,   187,   181,
     226,   109,   110,   111,   112,    15,    38,    39,    40,   198,
     199,   200,    43,    10,    46,    47,    13,   206,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    60,    61,
      62,    63,    65,    66,    67,    15,    68,    69,    70,    71,
      72,    73,     9,    10,    40,    41,    42,    14,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    10,     9,
      27,    13,    60,    61,    62,    63,    10,    10,     9,    13,
      13,    38,    39,    40,    72,    73,     1,     2,     3,    46,
      47,     9,    10,     9,     6,     4,    14,     8,   230,   231,
     232,   233,    15,    60,    61,    62,    63,   239,     3,    27,
      10,    68,    69,    70,    71,    72,    73,    10,    10,    10,
      38,    39,    40,    10,    51,    10,   239,   102,    46,    47,
       9,    10,    18,   104,   213,    14,   103,   105,   140,    -1,
     106,   181,    60,    61,    62,    63,    -1,    -1,    27,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    -1,    -1,    27,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,     9,    -1,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    -1,    -1,    27,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    -1,    -1,    -1,    -1,    68,    69,    70,    71,
      72,    73
  };

  const unsigned char
   Parser ::yystos_[] =
  {
       0,    65,    66,    67,    75,    76,    76,    76,    76,     0,
      77,    78,    79,    80,    81,     0,    78,     0,    13,    41,
      82,     3,     7,     8,    14,    26,    40,    48,    60,    61,
      62,    63,    64,    68,    71,    72,    73,    83,   112,    80,
       9,    27,    38,    39,    40,    46,    47,    60,    61,    62,
      63,    68,    69,    70,    72,    73,    83,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,     5,    84,    63,    98,   112,   116,    72,   112,   116,
       9,     9,     9,     9,     7,     9,     7,    48,    49,   110,
      12,    11,    25,    24,    44,    45,    43,    16,    17,    18,
      19,    22,    23,    20,    21,    40,    41,    42,    26,    38,
      27,    39,    27,    39,    50,    52,    55,    57,    58,    59,
      85,    86,    87,    88,    89,    90,    92,    95,    98,   114,
     115,    10,    40,    10,    13,    10,    98,   117,    10,   117,
      10,   117,    10,   117,   117,    10,   117,    98,    72,   112,
     112,    98,   101,   102,   103,   104,   105,   106,   106,   107,
     107,   107,   107,   109,   109,   110,   110,   110,   108,   108,
       9,     9,     9,     6,    85,     4,    15,    15,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,   118,    15,
     118,   110,    10,    40,   117,    10,    13,    10,    10,    10,
       8,    10,     8,     3,    98,    38,    83,   111,    98,    85,
      98,    98,    98,    98,    98,   110,    10,    10,    98,    99,
      10,    10,    10,    10,   110,    84,    84,    84,    84,    51,
      84,    90,    91
  };

  const unsigned char
   Parser ::yyr1_[] =
  {
       0,    74,    75,    76,    76,    76,    76,    77,    77,    78,
      78,    79,    79,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    85,    85,    86,    86,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    90,    90,    91,    91,
      92,    92,    92,    92,    92,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    95,    96,    96,    96,    96,
      96,    96,    97,    97,    97,    97,    98,    99,    99,   100,
     100,   101,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   106,   106,   106,   107,   107,   107,
     108,   108,   108,   108,   109,   109,   109,   110,   110,   110,
     110,   111,   111,   112,   112,   112,   112,   112,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   114,   114,
     115,   116,   116,   117,   117,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118
  };

  const unsigned char
   Parser ::yyr2_[] =
  {
       0,     2,     3,     2,     2,     2,     0,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     1,     1,
       3,     3,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     5,     1,     3,     3,     1,     4,
       1,     2,     2,     2,     2,     3,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     1,     3,     3,     1,     4,     5,
       6,     2,     1,     1,     1,     1,     1,     1,     3,     4,
       3,     4,     3,     4,     3,     4,     3,     4,     1,     4,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\":\"", "\";\"", "\"{\"",
  "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"builtin\"", "\"call\"",
  "\"call_builtin\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "probes", "probe", "attach_points", "attach_point", "attach_point_def",
  "pred", "param", "block", "stmt_list", "block_stmt", "expr_stmt",
  "jump_stmt", "loop_stmt", "if_stmt", "block_or_if", "assign_stmt",
  "primary_expr", "postfix_expr", "tuple_access_expr", "unary_expr",
  "unary_op", "expr", "conditional_expr", "logical_or_expr",
  "logical_and_expr", "or_expr", "xor_expr", "and_expr", "equality_expr",
  "relational_expr", "shift_expr", "muli_expr", "addi_expr", "cast_expr",
  "int", "ident", "call", "map", "var", "map_or_var", "vargs",
  "compound_op", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
   Parser ::yyrline_[] =
  {
       0,   162,   162,   166,   167,   168,   169,   173,   174,   178,
     188,   201,   202,   206,   210,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   236,   240,   241,   246,   257,
     261,   268,   269,   273,   274,   278,   279,   283,   284,   289,
     293,   294,   295,   299,   300,   301,   305,   306,   310,   311,
     315,   320,   321,   322,   327,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   354,   356,   357,   359,   361,
     362,   363,   364,   366,   367,   372,   378,   379,   380,   381,
     383,   384,   388,   389,   390,   391,   395,   399,   400,   405,
     406,   410,   411,   415,   416,   420,   421,   426,   427,   431,
     432,   433,   437,   438,   439,   440,   441,   445,   446,   447,
     451,   452,   453,   454,   458,   459,   460,   464,   465,   466,
     467,   471,   472,   476,   477,   478,   479,   480,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   497,   498,
     502,   506,   507,   511,   512,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525
  };

  // Print the state stack on the debug stream.
  void
   Parser ::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
   Parser ::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy" // lalr1.cc:1167
} //  bpftrace 
#line 2415 "/builddir/build/BUILD/bpftrace-0.16.0/parser.tab.cc" // lalr1.cc:1167
#line 528 "src/parser.yy" // lalr1.cc:1168


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
